/* 
MAT 259A Final Project
Stejara Iulia Dinulescu
Supervisor: George Legrady

Description: 


*/

Table table;
int rowCount;
int NUM_FEATURES = 24;
int NUM_SENSORS = 4;
int depth = 1000;
int maxAcc = 1;

ArrayList<Agent> agents = new ArrayList<Agent>();

import peasy.*;
PeasyCam cam;

void setup() {
  colorMode(HSB, 255);
  size(1000, 1000, P3D);
  background(0);
  
  cam = new PeasyCam(this, 0, 0, 0, depth);
  cam.lookAt(width/2,height/2, depth/2);
  cam.setMaximumDistance(depth * 5);
  cam.setMinimumDistance(-depth);
  
  table = loadTable("viz_features.csv", "header");
  rowCount = table.getRowCount();
  
  String prevl = "A";
  int trial_index = 0; 
  for (int i = 0; i < rowCount; i++) {
    String l = table.getRow(i).getString("Letter");
    if (l.equals(prevl)) { trial_index++; } else { trial_index = 1; }
    prevl = l;
    Agent a = new Agent(l, trial_index); 
    float[] temp_features = new float[NUM_FEATURES];
    int sensor_index = 0; // will go from 1 to NUM_SENSORS
    int feature_index = 0; // will go from 0 to NUM_FEATURES
    for (int j = 1; j <= NUM_FEATURES*NUM_SENSORS; j++) {
      temp_features[feature_index] = table.getRow(i).getFloat(j);
      feature_index++;
      if (feature_index >= NUM_FEATURES) {
        a.features[sensor_index] = temp_features;
        temp_features = new float[NUM_FEATURES]; // clear
        sensor_index++;
        feature_index = 0;
      }
    }
    a.setupMotionParameters();
    agents.add(a);
  }
  
  println("we have " + agents.size() + " agents stored.");
  agents.get(0).printGenotype();
}


void draw() {
  background(0);
  
  for (int i = 0; i < agents.size(); i++) {
   agents.get(i).display(); 
   agents.get(i).move();
   agents.get(i).handleBoundaries();
  }
  
}
